"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cron = __importStar(require("node-cron"));
const ck_lib_1 = require("@ckstack/ck-lib");
const MyValues_1 = require("./MyValues");
class CkCronService {
    static onRunTask(taskObj) {
        const lhd = `- [${taskObj.constructor.name}:] -`;
        if (taskObj.isRunning()) {
            ck_lib_1.CkLogger.infoLog2('on running task. wait next tick', lhd);
            return;
        }
        taskObj.init();
        taskObj.run(lhd);
    }
    static init(jobs) {
        CkCronService.TASK_CLS = jobs;
        ck_lib_1.CkLogger.infoLog2('CronService.init', MyValues_1.PROC_LHD.IP_LHD_HTTP);
    }
    static start(timeZone) {
        for (const row of CkCronService.TASK_CLS) {
            if (!cron.validate(row.schedule)) {
                ck_lib_1.CkLogger.printLogAndTerminateProcess(`invalid task [${row.taskObj.constructor.name}], scheudle [${row.schedule}]. process terminate.`, MyValues_1.PROC_LHD.IP_LHD_HTTP);
                return;
            }
            ck_lib_1.CkLogger.infoLog2(`cron task [${row.taskObj.constructor.name}], schedule [${row.schedule}] is valid`, MyValues_1.PROC_LHD.IP_LHD_HTTP);
            const task = cron.schedule(row.schedule, () => CkCronService.onRunTask(row.taskObj), { scheduled: false, timezone: timeZone || 'Asia/Seoul' });
            task.start();
        }
        ck_lib_1.CkLogger.infoLog2('start cron jobs', MyValues_1.PROC_LHD.IP_LHD_HTTP);
    }
}
exports.default = CkCronService;
CkCronService.TASK_CLS = [];
