interface ICronTaskRunInfo {
    running: boolean;
    lastRunningTm: number;
}
export default abstract class CkCronTask {
    protected TASK_STATE: ICronTaskRunInfo;
    /**
     * cron task 초기화. 상속 받는 곳에서 주로 overwrite 해서 사용 한다.
     */
    init(): void;
    /**
     * cron task 가 동작 중인지 확인
     */
    isRunning(): boolean;
    /**
     * cron task 동작 시작
     */
    setRunning(lhd: string): void;
    /**
     * cron task 종료
     * @param lhd
     */
    taskEnd(lhd: string): void;
    /**
     * 상속 받는 곳에서 구현 해야 한다.
     * @param lhd
     */
    abstract run(lhd: string): void;
}
export {};
